Bug 1315134 - Review Request: erlang-ezlib - Native zlib driver for Erlang
Review Request: erlang-ezlib - Native zlib driver for Erlang
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Randy Barlow
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1312517
  Show dependency treegraph
 
Reported: 2016-03-06 21:05 EST by Randy Barlow
Modified: 2016-03-31 11:00 EDT (History)
3 users (show)

See Also:
Fixed In Version: erlang-ezlib-1.0.1-5.fc25
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-03-31 11:00:58 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jeremy: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Randy Barlow 2016-03-06 21:05:36 EST
Spec URL: https://rbarlow.fedorapeople.org/erlang-ezlib.spec
SRPM URL: https://rbarlow.fedorapeople.org/erlang-ezlib-1.0.1-3.fc25.src.rpm
Description: A native zlib driver for Erlang / Elixir, used by ejabberd.
Fedora Account System Username: rbarlow

This is a package rename. Upstream renamed the package from p1_zlib to ezlib, so this package obsoletes erlang-p1_zlib.
Comment 1 Upstream Release Monitoring 2016-03-06 21:14:53 EST
rbarlow's scratch build of erlang-ezlib-1.0.1-3.fc25.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=13253788
Comment 2 Randy Barlow 2016-03-06 21:36:20 EST
Here are the lint outputs. The unstripped-binary-or-object and no-soname errors are typical for Erlang libraries and can be ignored.

Rpmlint
-------
Checking: erlang-ezlib-1.0.1-3.fc24.x86_64.rpm
          erlang-ezlib-1.0.1-3.fc24.src.rpm
erlang-ezlib.x86_64: W: spelling-error Summary(en_US) zlib -> lib, glib, z lib
erlang-ezlib.x86_64: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
erlang-ezlib.x86_64: W: spelling-error %description -l en_US ejabberd -> jabbered, jabberer, jabber
erlang-ezlib.x86_64: W: unstripped-binary-or-object /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so
erlang-ezlib.x86_64: W: no-soname /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so
erlang-ezlib.src: W: spelling-error Summary(en_US) zlib -> lib, glib, z lib
erlang-ezlib.src: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
erlang-ezlib.src: W: spelling-error %description -l en_US ejabberd -> jabbered, jabberer, jabber
2 packages and 0 specfiles checked; 0 errors, 8 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
erlang-ezlib.x86_64: W: spelling-error Summary(en_US) zlib -> lib, glib, z lib
erlang-ezlib.x86_64: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
erlang-ezlib.x86_64: W: spelling-error %description -l en_US ejabberd -> jabbered, jabberer, jabber
erlang-ezlib.x86_64: W: unstripped-binary-or-object /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so
erlang-ezlib.x86_64: W: no-soname /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so set_port_control_flags
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so driver_free
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so driver_alloc_binary
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so driver_alloc
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so driver_realloc_binary
1 packages and 0 specfiles checked; 0 errors, 10 warnings.
Comment 3 Peter Lemenkov 2016-03-15 09:18:44 EDT
Needs cleaning up.

* Please, remove unnecessary BuildRequires - erlang-eunit, erlang-rpm-macros.

* Please, remove explicit Requires. They will be picked up automatically.

* Please add dependency on a DRV version (we can't do it automatically yet). E.g. add "%{?__erlang_drv_version:Requires: %{__erlang_drv_version}}".

* Please, use macro %{rebar_eunit}.
Comment 4 Randy Barlow 2016-03-15 21:38:46 EDT
Привет Peter!

I have made the changes you requested in release 4 of this package:

Spec URL: https://rbarlow.fedorapeople.org/erlang-ezlib.spec
SRPM URL: https://rbarlow.fedorapeople.org/erlang-ezlib-1.0.1-4.fc25.src.rpm

I did not know about the erlang(erl_drv_version) requires line, thanks for sharing. To make sure I understand, the erl_drv requirement is needed for Erlang packages that use the Erlang C drivers (i.e., pretty much any Erlang package that has C code.) Is that correct?

Thanks for your help!
Comment 5 Peter Lemenkov 2016-03-16 06:50:23 EDT
Sorry, but I missed another one thing. You should remove "%global debug_package %{nil}" because this package contains so-library and therefore should have debuginfo sub-package.
Comment 6 Randy Barlow 2016-03-18 00:32:21 EDT
Hello Peter! I have added the debug package in release 5:

Spec URL: https://rbarlow.fedorapeople.org/erlang-ezlib.spec
SRPM URL: https://rbarlow.fedorapeople.org/erlang-ezlib-1.0.1-5.fc25.src.rpm
Comment 7 Jeremy Cline 2016-03-26 21:35:24 EDT
fedora-review failed to install the packages, but I installed them manually and encountered no problems.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package installs properly.
  Note: Installation errors (see attachment)
  See: https://fedoraproject.org/wiki/Packaging:Guidelines


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Unknown or generated". 4 files have unknown
     license. Detailed output of licensecheck in /home/vagrant/fedora-
     reviews/1315134-erlang-ezlib/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: erlang-ezlib-1.0.1-5.fc25.x86_64.rpm
          erlang-ezlib-debuginfo-1.0.1-5.fc25.x86_64.rpm
          erlang-ezlib-1.0.1-5.fc25.src.rpm
erlang-ezlib.x86_64: W: spelling-error Summary(en_US) zlib -> lib, glib, z lib
erlang-ezlib.x86_64: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
erlang-ezlib.x86_64: W: spelling-error %description -l en_US ejabberd -> jabbered, jabberer, jabber
erlang-ezlib.x86_64: W: no-soname /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so
erlang-ezlib.src: W: spelling-error Summary(en_US) zlib -> lib, glib, z lib
erlang-ezlib.src: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
erlang-ezlib.src: W: spelling-error %description -l en_US ejabberd -> jabbered, jabberer, jabber
3 packages and 0 specfiles checked; 0 errors, 7 warnings.


Rpmlint on installed packages
-----------------------------
[vagrant@fedora results]$ rpmlint erlang-ezlib erlang-ezlib-debuginfo
erlang-ezlib.x86_64: W: spelling-error Summary(en_US) zlib -> lib, glib, z lib
erlang-ezlib.x86_64: W: spelling-error %description -l en_US zlib -> lib, glib, z lib
erlang-ezlib.x86_64: W: spelling-error %description -l en_US ejabberd -> jabbered, jabberer, jabber
erlang-ezlib.x86_64: W: no-soname /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so set_port_control_flags
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so driver_free
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so driver_alloc_binary
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so driver_alloc
erlang-ezlib.x86_64: W: undefined-non-weak-symbol /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so driver_realloc_binary
2 packages and 0 specfiles checked; 0 errors, 9 warnings.


Requires
--------
erlang-ezlib-debuginfo (rpmlib, GLIBC filtered):

erlang-ezlib (rpmlib, GLIBC filtered):
    erlang(erl_drv_version)
    erlang-erts(x86-64)
    erlang-kernel(x86-64)
    erlang-stdlib(x86-64)
    libc.so.6()(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)



Provides
--------
erlang-ezlib-debuginfo:
    erlang-ezlib-debuginfo
    erlang-ezlib-debuginfo(x86-64)

erlang-ezlib:
    erlang-ezlib
    erlang-ezlib(x86-64)
    erlang-p1_zlib



Unversioned so-files
--------------------
erlang-ezlib: /usr/lib64/erlang/lib/ezlib-1.0.1/priv/lib/ezlib_drv.so

Source checksums
----------------
https://github.com/processone/ezlib/archive/1.0.1.tar.gz :
  CHECKSUM(SHA256) this package     : 7d867a7c0e2109264f8000d31d7824f6ffa375858617b63165a7f4728688d84a
  CHECKSUM(SHA256) upstream package : 7d867a7c0e2109264f8000d31d7824f6ffa375858617b63165a7f4728688d84a


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1315134
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Note You need to log in before you can comment on or make changes to this bug.